/*
 * Mapped memory region support.
 *
 * Copyright (C) 2022 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/sys/types.h>

#include <systypes/base.h>



/* A mapped region abstraction. */

class MappedRegion
{
public:
  l4_addr_t start;
  offset_t size;
  l4_umword_t flags;
  l4_cap_idx_t ds;
  l4_addr_t ds_start;

  explicit MappedRegion()
  : start(0), size(0), flags(0), ds(L4_INVALID_CAP), ds_start(0)
  {
  }

  explicit MappedRegion(l4_addr_t start, l4_addr_t size,
                        l4_umword_t flags, l4_cap_idx_t ds = L4_INVALID_CAP,
                        l4_addr_t ds_start = 0)
  : start(start), size(size), flags(flags), ds(ds), ds_start(ds_start)
  {
  }
};

/* vim: tabstop=2 expandtab shiftwidth=2
*/
